unit ComplexExpressIt;

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExpressionParser,Variants;

//==============================================================================
type
  TComplexExpressIt = class(TCustomExpressIt)
  public
    // alpha, no omega in this case
    constructor Create(AOwner: TComponent); override;
  published
    // expose ourselves
    property AutoExecute;
    property Expression;
    property ResultText;
    property OnLateValue;
    property OnLateObject;
  end;

//==============================================================================
procedure Register;

//==============================================================================
function GlobalComplexExpressIt: TComplexExpressIt;
function ComplexEvaluateIt(const aExpression: string): variant;

//==============================================================================
implementation

//==============================================================================
uses
  MiscSupport, ParserSupport, Expression,
  ExpressionOpersComplex, ExpressionFuncsComplex;

//==============================================================================
procedure Register;
begin
  RegisterComponents('Additional', [TComplexExpressIt]);
end;

//==============================================================================
// TComplexExpressIt = class(TCustomExpressIt)
//==============================================================================
constructor TComplexExpressIt.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ValidValues := [evvNumber, evvIdent];

  // add the lexicons
  ExpressionOpersComplex.RegisterLexicon(Self);
  ExpressionFuncsComplex.RegisterLexicon(Self);
end;

//==============================================================================
var
  vComplexExpressIt: TComplexExpressIt = nil;
  vUnitOk: boolean = True;
function GlobalComplexExpressIt: TComplexExpressIt;
begin
  // have we made one yet?
  if vUnitOk and
     not Assigned(vComplexExpressIt) then
    vComplexExpressIt := TComplexExpressIt.Create(nil);

  // return it!
  Result := vComplexExpressIt;
end;
function ComplexEvaluateIt(const aExpression: string): variant;
begin
  // all is swell?
  if GlobalComplexExpressIt <> nil then
    Result := GlobalComplexExpressIt.Evaluate(aExpression)
  else
    Result := Unassigned;
end;

//==============================================================================
initialization
  // nothing to do here!
finalization
  vUnitOk := False;
  Dump(vComplexExpressIt);
end.
