unit ExpressionFuncsComplex;

// values      = True, False, Pi
// conversion  = AsInteger, AsBoolean, AsReal, AsComplex,
// testing     = IsComplex, IsEmpty, IsNull
// conditional = IfThen
// complex     = RealOf, ImaginaryOf, ComplexFor, Simplify, Conjugate, Inverse
//               TimesPosI, TimesNegI, Norm, Angle, Exp, Ln, SquareRoot
// trig        = Cos, Sin, Tan, ArcCos, ArcSin, ArcTan,
//               CosH, SinH, TanH, ArcCosH, ArcSinH, ArcTanH


//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser,Variants;

//==============================================================================
type
  //============================================================================
  // value
  TExpressionFuncTrue = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncFalse = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncPi = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  //============================================================================
  // conversion
  TExpressionFuncAsInteger = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncAsBoolean = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncAsReal = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncAsComplex = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  //============================================================================
  // testing
  TExpressionFuncIsComplex = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsEmpty = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsNull = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  //============================================================================
  // conditional
  TExpressionFuncIfThen = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  //============================================================================
  // complex
  TExpressionFuncRealPartOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncImaginaryPartOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncComplexFor = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSimplify = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncConjugate = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncInverse = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTimesPosI = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTimesNegI = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncNorm = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncAngle = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncExp = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncLn = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSquareRoot = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  //============================================================================
  // trig
  TExpressionFuncCos = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSin = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTan = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcCos = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcSin = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcTan = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncCosH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSinH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTanH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcCosH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcSinH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncArcTanH = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport, MiscSupport, ComplexSupport;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncTrue);
    Add(TExpressionFuncFalse);
    Add(TExpressionFuncPi);

    Add(TExpressionFuncAsInteger);
    Add(TExpressionFuncAsBoolean);
    Add(TExpressionFuncAsReal);
    Add(TExpressionFuncAsComplex);

    Add(TExpressionFuncIsComplex);
    Add(TExpressionFuncIsEmpty);
    Add(TExpressionFuncIsNull);

    Add(TExpressionFuncIfThen);

    Add(TExpressionFuncRealPartOf);
    Add(TExpressionFuncImaginaryPartOf);
    Add(TExpressionFuncComplexFor);
    Add(TExpressionFuncSimplify);
    Add(TExpressionFuncConjugate);
    Add(TExpressionFuncInverse);
    Add(TExpressionFuncTimesPosI);
    Add(TExpressionFuncTimesNegI);
    Add(TExpressionFuncNorm);
    Add(TExpressionFuncAngle);
    Add(TExpressionFuncExp);
    Add(TExpressionFuncLn);
    Add(TExpressionFuncSquareRoot);

    Add(TExpressionFuncCos);
    Add(TExpressionFuncSin);
    Add(TExpressionFuncTan);
    Add(TExpressionFuncArcCos);
    Add(TExpressionFuncArcSin);
    Add(TExpressionFuncArcTan);
    Add(TExpressionFuncCosH);
    Add(TExpressionFuncSinH);
    Add(TExpressionFuncTanH);
    Add(TExpressionFuncArcCosH);
    Add(TExpressionFuncArcSinH);
    Add(TExpressionFuncArcTanH);
  end;
end;

//==============================================================================
// TExpressionFuncTrue = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncTrue.Symbol: string;
begin
  Result := 'True';
end;
procedure TExpressionFuncTrue.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(True);
end;

//==============================================================================
// TExpressionFuncFalse = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncFalse.Symbol: string;
begin
  Result := 'False';
end;
procedure TExpressionFuncFalse.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(False);
end;

//==============================================================================
// TExpressionFuncPi = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncPi.Symbol: string;
begin
  Result := 'Pi';
end;
procedure TExpressionFuncPi.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Pi);
end;

//==============================================================================
// TExpressionFuncAsInteger = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAsInteger.Symbol: string;
begin
  Result := 'AsInteger';
end;
procedure TExpressionFuncAsInteger.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexAsType(Pop, varInteger));
end;

//==============================================================================
// TExpressionFuncAsBoolean = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAsBoolean.Symbol: string;
begin
  Result := 'AsBoolean';
end;
procedure TExpressionFuncAsBoolean.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexAsType(Pop, varBoolean));
end;

//==============================================================================
// TExpressionFuncAsReal = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAsReal.Symbol: string;
begin
  Result := 'AsReal';
end;
procedure TExpressionFuncAsReal.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexAsType(Pop, varDouble));
end;

//==============================================================================
// TExpressionFuncAsComplex = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAsComplex.Symbol: string;
begin
  Result := 'AsComplex';
end;
procedure TExpressionFuncAsComplex.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarAsComplex(Pop));
end;

//==============================================================================
// TExpressionFuncIsComplex = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsComplex.Symbol: string;
begin
  Result := 'IsComplex';
end;
procedure TExpressionFuncIsComplex.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarIsComplex(Pop));
end;

//==============================================================================
// TExpressionFuncIsEmpty = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsEmpty.Symbol: string;
begin
  Result := 'IsEmpty';
end;
procedure TExpressionFuncIsEmpty.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarIsEmpty(Pop));
end;

//==============================================================================
// TExpressionFuncIsNull = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsNull.Symbol: string;
begin
  Result := 'IsNull';
end;
procedure TExpressionFuncIsNull.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarIsNull(Pop));
end;

//==============================================================================
// TExpressionFuncIfThen = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncIfThen.Symbol: string;
begin
  Result := 'IfThen';
end;
procedure TExpressionFuncIfThen.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen, vElse: variant;
begin
  with AStack do begin
    vElse := Pop;
    vThen := Pop;
    if VarComplexAsType(Pop, varBoolean) then
      Push(vThen)
    else
      Push(vElse);
  end;
end;

//==============================================================================
// TExpressionFuncRealPartOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncRealPartOf.Symbol: string;
begin
  Result := 'RealPartOf';
end;
procedure TExpressionFuncRealPartOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(RealPartOfVarComplex(Pop));
end;

//==============================================================================
// TExpressionFuncImaginaryPartOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncImaginaryPartOf.Symbol: string;
begin
  Result := 'ImaginaryPartOf';
end;
procedure TExpressionFuncImaginaryPartOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(ImaginaryPartOfVarComplex(Pop));
end;

//==============================================================================
// TExpressionFuncComplexFor = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncComplexFor.Symbol: string;
begin
  Result := 'ComplexFor';
end;
procedure TExpressionFuncComplexFor.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vValue: variant;
begin
  with AStack do begin
    vValue := Pop;
    Push(VarComplexFor(Pop, vValue));
  end;
end;

//==============================================================================
// TExpressionFuncSimplify = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSimplify.Symbol: string;
begin
  Result := 'Simplify';
end;
procedure TExpressionFuncSimplify.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarSimplify(Pop));
end;

//==============================================================================
// TExpressionFuncConjugate = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncConjugate.Symbol: string;
begin
  Result := 'Conjugate';
end;
procedure TExpressionFuncConjugate.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexConjugate(Pop));
end;

//==============================================================================
// TExpressionFuncInverse = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncInverse.Symbol: string;
begin
  Result := 'Inverse';
end;
procedure TExpressionFuncInverse.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexInverse(Pop));
end;

//==============================================================================
// TExpressionFuncTimesPosI = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTimesPosI.Symbol: string;
begin
  Result := 'TimesPosI';
end;
procedure TExpressionFuncTimesPosI.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexTimesPosI(Pop));
end;

//==============================================================================
// TExpressionFuncTimesNegI = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTimesNegI.Symbol: string;
begin
  Result := 'TimesNegI';
end;
procedure TExpressionFuncTimesNegI.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexTimesNegI(Pop));
end;

//==============================================================================
// TExpressionFuncNorm = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncNorm.Symbol: string;
begin
  Result := 'Norm';
end;
procedure TExpressionFuncNorm.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexNorm(Pop));
end;

//==============================================================================
// TExpressionFuncAngle = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAngle.Symbol: string;
begin
  Result := 'Angle';
end;
procedure TExpressionFuncAngle.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexAngle(Pop));
end;

//==============================================================================
// TExpressionFuncExp = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncExp.Symbol: string;
begin
  Result := 'Exp';
end;
procedure TExpressionFuncExp.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexExp(Pop));
end;

//==============================================================================
// TExpressionFuncLn = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncLn.Symbol: string;
begin
  Result := 'Ln';
end;
procedure TExpressionFuncLn.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexLn(Pop));
end;

//==============================================================================
// TExpressionFuncSquareRoot = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSquareRoot.Symbol: string;
begin
  Result := 'SquareRoot';
end;
procedure TExpressionFuncSquareRoot.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexSquareRoot(Pop));
end;

//==============================================================================
// TExpressionFuncCos = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCos.Symbol: string;
begin
  Result := 'Cos';
end;
procedure TExpressionFuncCos.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexCos(Pop));
end;

//==============================================================================
// TExpressionFuncSin = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSin.Symbol: string;
begin
  Result := 'Sin';
end;
procedure TExpressionFuncSin.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexSin(Pop));
end;

//==============================================================================
// TExpressionFuncTan = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTan.Symbol: string;
begin
  Result := 'Tan';
end;
procedure TExpressionFuncTan.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexTan(Pop));
end;

//==============================================================================
// TExpressionFuncArcCos = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcCos.Symbol: string;
begin
  Result := 'ArcCos';
end;
procedure TExpressionFuncArcCos.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcCos(Pop));
end;

//==============================================================================
// TExpressionFuncArcSin = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcSin.Symbol: string;
begin
  Result := 'ArcSin';
end;
procedure TExpressionFuncArcSin.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcSin(Pop));
end;

//==============================================================================
// TExpressionFuncArcTan = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcTan.Symbol: string;
begin
  Result := 'ArcTan';
end;
procedure TExpressionFuncArcTan.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcTan(Pop));
end;

//==============================================================================
// TExpressionFuncCosH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCosH.Symbol: string;
begin
  Result := 'CosH';
end;
procedure TExpressionFuncCosH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexCosH(Pop));
end;

//==============================================================================
// TExpressionFuncSinH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSinH.Symbol: string;
begin
  Result := 'SinH';
end;
procedure TExpressionFuncSinH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexSinH(Pop));
end;

//==============================================================================
// TExpressionFuncTanH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTanH.Symbol: string;
begin
  Result := 'TanH';
end;
procedure TExpressionFuncTanH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexTanH(Pop));
end;

//==============================================================================
// TExpressionFuncArcCosH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcCosH.Symbol: string;
begin
  Result := 'ArcCosH';
end;
procedure TExpressionFuncArcCosH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcCosH(Pop));
end;

//==============================================================================
// TExpressionFuncArcSinH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcSinH.Symbol: string;
begin
  Result := 'ArcSinH';
end;
procedure TExpressionFuncArcSinH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcSinH(Pop));
end;

//==============================================================================
// TExpressionFuncArcTanH = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcTanH.Symbol: string;
begin
  Result := 'ArcTanH';
end;
procedure TExpressionFuncArcTanH.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarComplexArcTanH(Pop));
end;

end.
