unit ExpressionFuncsDateTime;

// datetime =       Now
// datetime =       TheDate
// datetime =       TheTime
// datetime =       AsDateTime(value)
// datetime =       DateOf()

// datetime =       TimeOf()
// integer  =       YearOf()
// integer  =       MonthOf()
// integer  =       WeekOf()
// integer  =       DayOf()

// integer  =       HourOf()
// integer  =       MinuteOf()
// integer  =       SecondOf()
// integer  =       MilliSecondOf()
// integer  =       DayOfYearOf()

// integer  =       DayOfWeekOf()
// datetime =       DateFor(y, m, d)
// datetime =       TimeFor(h, m, s, ms)
// datetime =       DateTimeFor(y, m, d, h, m, s, ms)

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser,Variants;

//==============================================================================
type
  //============================================================================
  // datetime
  TExpressionFuncNow = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTheDate = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTheTime = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncAsDateTime = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDateOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTimeOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncYearOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMonthOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWeekOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOfYearOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOfWeekOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDateFor = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncTimeFor = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDateTimeFor = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
    class function ArgCount: integer; override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport, DateTimeSupport;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncNow);
    Add(TExpressionFuncTheDate);
    Add(TExpressionFuncTheTime);
    Add(TExpressionFuncAsDateTime);
    Add(TExpressionFuncDateOf);

    Add(TExpressionFuncTimeOf);
    Add(TExpressionFuncYearOf);
    Add(TExpressionFuncMonthOf);
    Add(TExpressionFuncWeekOf);
    Add(TExpressionFuncDayOf);

    Add(TExpressionFuncHourOf);
    Add(TExpressionFuncMinuteOf);
    Add(TExpressionFuncSecondOf);
    Add(TExpressionFuncMilliSecondOf);
    Add(TExpressionFuncDayOfYearOf);

    Add(TExpressionFuncDayOfWeekOf);
    Add(TExpressionFuncDateFor);
    Add(TExpressionFuncTimeFor);
    Add(TExpressionFuncDateTimeFor);
  end;
end;

//==============================================================================
// TExpressionFuncNow = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncNow.Symbol: string;
begin
  Result := 'Now';
end;
procedure TExpressionFuncNow.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Now);
end;

//==============================================================================
// TExpressionFuncTheDate = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncTheDate.Symbol: string;
begin
  Result := 'TheDate';
end;
procedure TExpressionFuncTheDate.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Date);
end;

//==============================================================================
// TExpressionFuncTheTime = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncTheTime.Symbol: string;
begin
  Result := 'TheTime';
end;
procedure TExpressionFuncTheTime.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Time);
end;

//==============================================================================
// TExpressionFuncAsDateTime = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncAsDateTime.Symbol: string;
begin
  Result := 'AsDateTime';
end;
procedure TExpressionFuncAsDateTime.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(VarAsType(Pop, varDate));
end;

//==============================================================================
// TExpressionFuncDateOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDateOf.Symbol: string;
begin
  Result := 'DateOf';
end;
procedure TExpressionFuncDateOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(DateOf(Pop));
end;

//==============================================================================
// TExpressionFuncTimeOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTimeOf.Symbol: string;
begin
  Result := 'TimeOf';
end;
procedure TExpressionFuncTimeOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(TimeOf(Pop));
end;

//==============================================================================
// TExpressionFuncYearOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncYearOf.Symbol: string;
begin
  Result := 'YearOf';
end;
procedure TExpressionFuncYearOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(YearOf(Pop));
end;

//==============================================================================
// TExpressionFuncMonthOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMonthOf.Symbol: string;
begin
  Result := 'MonthOf';
end;
procedure TExpressionFuncMonthOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(MonthOf(Pop));
end;

//==============================================================================
// TExpressionFuncWeekOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncWeekOf.Symbol: string;
begin
  Result := 'WeekOf';
end;
procedure TExpressionFuncWeekOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(WeekOfYear(Pop));
end;

//==============================================================================
// TExpressionFuncDayOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOf.Symbol: string;
begin
  Result := 'DayOf';
end;
procedure TExpressionFuncDayOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(DayOf(Pop));
end;

//==============================================================================
// TExpressionFuncHourOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncHourOf.Symbol: string;
begin
  Result := 'HourOf';
end;
procedure TExpressionFuncHourOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(HourOf(Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOf.Symbol: string;
begin
  Result := 'MinuteOf';
end;
procedure TExpressionFuncMinuteOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(MinuteOf(Pop));
end;

//==============================================================================
// TExpressionFuncSecondOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOf.Symbol: string;
begin
  Result := 'SecondOf';
end;
procedure TExpressionFuncSecondOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(SecondOf(Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOf.Symbol: string;
begin
  Result := 'MilliSecondOf';
end;
procedure TExpressionFuncMilliSecondOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(MilliSecondOf(Pop));
end;

//==============================================================================
// TExpressionFuncDayOfYearOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOfYearOf.Symbol: string;
begin
  Result := 'DayOfYearOf';
end;
procedure TExpressionFuncDayOfYearOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(DayOfYear(Pop));
end;

//==============================================================================
// TExpressionFuncDayOfWeekOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOfWeekOf.Symbol: string;
begin
  Result := 'DayOfWeekOf';
end;
procedure TExpressionFuncDayOfWeekOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(DayOfWeek(Pop));
end;

//==============================================================================
// TExpressionFuncDateFor = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncDateFor.Symbol: string;
begin
  Result := 'DateFor';
end;
procedure TExpressionFuncDateFor.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMonth, vDay: word;
begin
  with AStack do begin
    vDay := Pop;
    vMonth := Pop;
    Push(EncodeDate(Pop, vMonth, vDay));
  end;
end;

//==============================================================================
// TExpressionFuncTimeFor = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncTimeFor.Symbol: string;
begin
  Result := 'TimeFor';
end;
procedure TExpressionFuncTimeFor.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMinute, vSecond: word;
begin
  with AStack do begin
    vSecond := Pop;
    vMinute := Pop;
    Push(EncodeTime(Pop, vMinute, vSecond, 0));
  end;
end;

//==============================================================================
// TExpressionFuncDateTimeFor = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncDateTimeFor.Symbol: string;
begin
  Result := 'DateTimeFor';
end;
procedure TExpressionFuncDateTimeFor.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMonth, vDay, vHour, vMinute, vSecond: word;
begin
  with AStack do begin
    vSecond := Pop;
    vMinute := Pop;
    vHour := Pop;
    vDay := Pop;
    vMonth := Pop;
    Push(EncodeDate(Pop, vMonth, vDay) + EncodeTime(vHour, vMinute, vSecond, 0));
  end;
end;
class function TExpressionFuncDateTimeFor.ArgCount: integer;
begin
  Result := 6;
end;

end.
