unit ExpressionFuncsDateTimeExtended;

//==============================================================================
// boolean  =       IsLeapYear(year)
// boolean  =       IsInLeapYear(datetime)
// integer  =       DaysInAMonth(year, month)
// integer  =       DaysInMonth(datetime)
// integer  =       DaysInAYear(year)
// integer  =       DaysInYear(datetime)
//
// datetime =       StartOfYear(datetime)
// datetime =       EndOfYear(datetime)
// datetime =       StartOfMonth(datetime)
// datetime =       EndOfMonth(datetime)
// datetime =       StartOfWeek(datetime)
// datetime =       EndOfWeek(datetime)
// datetime =       StartOfDay(datetime)
// datetime =       EndOfDay(datetime)
//
// integer  =       MonthOfYear(datetime)
// integer  =       WeekOfYear(datetime)
// integer  =       DayOfYear(datetime)
// comp     =       HourOfYear(datetime)
// comp     =       MinuteOfYear(datetime)
// comp     =       SecondOfYear(datetime)
// comp     =       MilliSecondOfYear(datetime)
//
// integer  =       WeekOfMonth(datetime)
// integer  =       DayOfMonth(datetime)
// comp     =       HourOfMonth(datetime)
// comp     =       MinuteOfMonth(datetime)
// comp     =       SecondOfMonth(datetime)
// comp     =       MilliSecondOfMonth(datetime)
//
// integer  =       DayOfWeek(datetime)
// comp     =       HourOfWeek(datetime)
// comp     =       MinuteOfWeek(datetime)
// comp     =       SecondOfWeek(datetime)
// comp     =       MilliSecondOfWeek(datetime)
//
// comp     =       HourOfDay(datetime)
// comp     =       MinuteOfDay(datetime)
// comp     =       SecondOfDay(datetime)
// comp     =       MilliSecondOfDay(datetime)
//
// comp     =       MinuteOfHour(datetime)
// comp     =       SecondOfHour(datetime)
// comp     =       MilliSecondOfHour(datetime)
//
// comp     =       SecondOfMinute(datetime)
// comp     =       MilliSecondOfMinute(datetime)
//
// comp     =       MilliSecondOfSecond(datetime)


//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser;

//==============================================================================
type
  //============================================================================
  // datetime
  TExpressionFuncIsLeapYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsInLeapYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaysInAMonth = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaysInMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaysInAYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaysInYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncStartOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEndOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncStartOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEndOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncStartOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEndOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncStartOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEndOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMonthOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWeekOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfYear = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWeekOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfMonth = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDayOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfWeek = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfDay = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteOfHour = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfHour = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfHour = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondOfMinute = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfMinute = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondOfSecond = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport, DateTimeSupport;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncIsLeapYear);
    Add(TExpressionFuncIsInLeapYear);
    Add(TExpressionFuncDaysInAMonth);
    Add(TExpressionFuncDaysInMonth);
    Add(TExpressionFuncDaysInAYear);
    Add(TExpressionFuncDaysInYear);
    Add(TExpressionFuncStartOfYear);
    Add(TExpressionFuncEndOfYear);
    Add(TExpressionFuncStartOfMonth);
    Add(TExpressionFuncEndOfMonth);
    Add(TExpressionFuncStartOfWeek);
    Add(TExpressionFuncEndOfWeek);
    Add(TExpressionFuncStartOfDay);
    Add(TExpressionFuncEndOfDay);
    Add(TExpressionFuncMonthOfYear);
    Add(TExpressionFuncWeekOfYear);
    Add(TExpressionFuncDayOfYear);
    Add(TExpressionFuncHourOfYear);
    Add(TExpressionFuncMinuteOfYear);
    Add(TExpressionFuncSecondOfYear);
    Add(TExpressionFuncMilliSecondOfYear);
    Add(TExpressionFuncWeekOfMonth);
    Add(TExpressionFuncDayOfMonth);
    Add(TExpressionFuncHourOfMonth);
    Add(TExpressionFuncMinuteOfMonth);
    Add(TExpressionFuncSecondOfMonth);
    Add(TExpressionFuncMilliSecondOfMonth);
    Add(TExpressionFuncDayOfWeek);
    Add(TExpressionFuncHourOfWeek);
    Add(TExpressionFuncMinuteOfWeek);
    Add(TExpressionFuncSecondOfWeek);
    Add(TExpressionFuncMilliSecondOfWeek);
    Add(TExpressionFuncHourOfDay);
    Add(TExpressionFuncMinuteOfDay);
    Add(TExpressionFuncSecondOfDay);
    Add(TExpressionFuncMilliSecondOfDay);
    Add(TExpressionFuncMinuteOfHour);
    Add(TExpressionFuncSecondOfHour);
    Add(TExpressionFuncMilliSecondOfHour);
    Add(TExpressionFuncSecondOfMinute);
    Add(TExpressionFuncMilliSecondOfMinute);
    Add(TExpressionFuncMilliSecondOfSecond);
  end;
end;

//==============================================================================
// TExpressionFuncIsLeapYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsLeapYear.Symbol: string;
begin
  Result := 'IsLeapYear';
end;
procedure TExpressionFuncIsLeapYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(IsLeapYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncIsInLeapYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsInLeapYear.Symbol: string;
begin
  Result := 'IsInLeapYear';
end;
procedure TExpressionFuncIsInLeapYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(IsInLeapYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDaysInAMonth = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncDaysInAMonth.Symbol: string;
begin
  Result := 'DaysInAMonth';
end;
procedure TExpressionFuncDaysInAMonth.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMonth: integer;
begin
  with AStack do begin
    vMonth := Pop;
    AStack.Push(DaysInAMonth(Pop, vMonth));
  end;
end;

//==============================================================================
// TExpressionFuncDaysInMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDaysInMonth.Symbol: string;
begin
  Result := 'DaysInMonth';
end;
procedure TExpressionFuncDaysInMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DaysInMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDaysInAYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDaysInAYear.Symbol: string;
begin
  Result := 'DaysInAYear';
end;
procedure TExpressionFuncDaysInAYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DaysInAYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDaysInYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDaysInYear.Symbol: string;
begin
  Result := 'DaysInYear';
end;
procedure TExpressionFuncDaysInYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DaysInYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncStartOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncStartOfYear.Symbol: string;
begin
  Result := 'StartOfYear';
end;
procedure TExpressionFuncStartOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(StartOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncEndOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEndOfYear.Symbol: string;
begin
  Result := 'EndOfYear';
end;
procedure TExpressionFuncEndOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(EndOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncStartOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncStartOfMonth.Symbol: string;
begin
  Result := 'StartOfMonth';
end;
procedure TExpressionFuncStartOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(StartOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncEndOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEndOfMonth.Symbol: string;
begin
  Result := 'EndOfMonth';
end;
procedure TExpressionFuncEndOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(EndOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncStartOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncStartOfWeek.Symbol: string;
begin
  Result := 'StartOfWeek';
end;
procedure TExpressionFuncStartOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(StartOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncEndOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEndOfWeek.Symbol: string;
begin
  Result := 'EndOfWeek';
end;
procedure TExpressionFuncEndOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(EndOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncStartOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncStartOfDay.Symbol: string;
begin
  Result := 'StartOfDay';
end;
procedure TExpressionFuncStartOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(StartOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncEndOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEndOfDay.Symbol: string;
begin
  Result := 'EndOfDay';
end;
procedure TExpressionFuncEndOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(EndOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMonthOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMonthOfYear.Symbol: string;
begin
  Result := 'MonthOfYear';
end;
procedure TExpressionFuncMonthOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MonthOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncWeekOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncWeekOfYear.Symbol: string;
begin
  Result := 'WeekOfYear';
end;
procedure TExpressionFuncWeekOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(WeekOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDayOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOfYear.Symbol: string;
begin
  Result := 'DayOfYear';
end;
procedure TExpressionFuncDayOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DayOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncHourOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncHourOfYear.Symbol: string;
begin
  Result := 'HourOfYear';
end;
procedure TExpressionFuncHourOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(HourOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOfYear.Symbol: string;
begin
  Result := 'MinuteOfYear';
end;
procedure TExpressionFuncMinuteOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MinuteOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfYear.Symbol: string;
begin
  Result := 'SecondOfYear';
end;
procedure TExpressionFuncSecondOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfYear = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfYear.Symbol: string;
begin
  Result := 'MilliSecondOfYear';
end;
procedure TExpressionFuncMilliSecondOfYear.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfYear(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncWeekOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncWeekOfMonth.Symbol: string;
begin
  Result := 'WeekOfMonth';
end;
procedure TExpressionFuncWeekOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(WeekOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDayOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOfMonth.Symbol: string;
begin
  Result := 'DayOfMonth';
end;
procedure TExpressionFuncDayOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DayOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncHourOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncHourOfMonth.Symbol: string;
begin
  Result := 'HourOfMonth';
end;
procedure TExpressionFuncHourOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(HourOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOfMonth.Symbol: string;
begin
  Result := 'MinuteOfMonth';
end;
procedure TExpressionFuncMinuteOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MinuteOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfMonth.Symbol: string;
begin
  Result := 'SecondOfMonth';
end;
procedure TExpressionFuncSecondOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfMonth = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfMonth.Symbol: string;
begin
  Result := 'MilliSecondOfMonth';
end;
procedure TExpressionFuncMilliSecondOfMonth.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfMonth(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncDayOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDayOfWeek.Symbol: string;
begin
  Result := 'DayOfWeek';
end;
procedure TExpressionFuncDayOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(DayOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncHourOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncHourOfWeek.Symbol: string;
begin
  Result := 'HourOfWeek';
end;
procedure TExpressionFuncHourOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(HourOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOfWeek.Symbol: string;
begin
  Result := 'MinuteOfWeek';
end;
procedure TExpressionFuncMinuteOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MinuteOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfWeek.Symbol: string;
begin
  Result := 'SecondOfWeek';
end;
procedure TExpressionFuncSecondOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfWeek = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfWeek.Symbol: string;
begin
  Result := 'MilliSecondOfWeek';
end;
procedure TExpressionFuncMilliSecondOfWeek.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfWeek(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncHourOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncHourOfDay.Symbol: string;
begin
  Result := 'HourOfDay';
end;
procedure TExpressionFuncHourOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(HourOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOfDay.Symbol: string;
begin
  Result := 'MinuteOfDay';
end;
procedure TExpressionFuncMinuteOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MinuteOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfDay.Symbol: string;
begin
  Result := 'SecondOfDay';
end;
procedure TExpressionFuncSecondOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfDay = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfDay.Symbol: string;
begin
  Result := 'MilliSecondOfDay';
end;
procedure TExpressionFuncMilliSecondOfDay.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfDay(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMinuteOfHour = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMinuteOfHour.Symbol: string;
begin
  Result := 'MinuteOfHour';
end;
procedure TExpressionFuncMinuteOfHour.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MinuteOfHour(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfHour = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfHour.Symbol: string;
begin
  Result := 'SecondOfHour';
end;
procedure TExpressionFuncSecondOfHour.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfHour(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfHour = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfHour.Symbol: string;
begin
  Result := 'MilliSecondOfHour';
end;
procedure TExpressionFuncMilliSecondOfHour.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfHour(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncSecondOfMinute = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSecondOfMinute.Symbol: string;
begin
  Result := 'SecondOfMinute';
end;
procedure TExpressionFuncSecondOfMinute.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(SecondOfMinute(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfMinute = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfMinute.Symbol: string;
begin
  Result := 'MilliSecondOfMinute';
end;
procedure TExpressionFuncMilliSecondOfMinute.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfMinute(AStack.Pop));
end;

//==============================================================================
// TExpressionFuncMilliSecondOfSecond = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncMilliSecondOfSecond.Symbol: string;
begin
  Result := 'MilliSecondOfSecond';
end;
procedure TExpressionFuncMilliSecondOfSecond.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(MilliSecondOfSecond(AStack.Pop));
end;

end.
