unit ExpressionFuncsDateTimeSpan;

// boolean  =       WithinPastYears(now, then, years)
// boolean  =       WithinPastMonths(now, then, months)
// boolean  =       WithinPastWeeks(now, then, weeks)
// boolean  =       WithinPastDays(now, then, days)
// boolean  =       WithinPastHours(now, then, hours)
// boolean  =       WithinPastMinutes(now, then, minutes)
// boolean  =       WithinPastSeconds(now, then, seconds)
// boolean  =       WithinPastMilliSeconds(now, then, milliseconds)
//
// these include only the scale you ask for, these are all really integers
// double   =       YearsBetween(now, then)
// double   =       MonthsBetween(now, then)
// double   =       WeeksBetween(now, then)
// double   =       DaysBetween(now, then)
// double   =       HoursBetween(now, then)
// double   =       MinutesBetween(now, then)
// double   =       SecondsBetween(now, then)
// double   =       MilliSecondsBetween(now, then)
//
// these also include fractional sub scale of what you ask for
// double   =       YearSpan(now, then)
// double   =       MonthSpan(now, then)
// double   =       WeekSpan(now, then)
// double   =       DaySpan(now, then)
// double   =       HourSpan(now, then)
// double   =       MinuteSpan(now, then)
// double   =       SecondSpan(now, then)
// double   =       MilliSecondSpan(now, then)

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser;

//==============================================================================
type
  //============================================================================
  TExpressionFuncWithinPastYears = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastMonths = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastWeeks = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastDays = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastHours = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastMinutes = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastSeconds = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWithinPastMilliSeconds = class(TExpressionFunctionWith3Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncYearsBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMonthsBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWeeksBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaysBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHoursBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinutesBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondsBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondsBetween = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncYearSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMonthSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncWeekSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDaySpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncHourSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMinuteSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncSecondSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncMilliSecondSpan = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport, DateTimeSupport;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncWithinPastYears);
    Add(TExpressionFuncWithinPastMonths);
    Add(TExpressionFuncWithinPastWeeks);
    Add(TExpressionFuncWithinPastDays);
    Add(TExpressionFuncWithinPastHours);
    Add(TExpressionFuncWithinPastMinutes);
    Add(TExpressionFuncWithinPastSeconds);
    Add(TExpressionFuncWithinPastMilliSeconds);
    Add(TExpressionFuncYearsBetween);
    Add(TExpressionFuncMonthsBetween);
    Add(TExpressionFuncWeeksBetween);
    Add(TExpressionFuncDaysBetween);
    Add(TExpressionFuncHoursBetween);
    Add(TExpressionFuncMinutesBetween);
    Add(TExpressionFuncSecondsBetween);
    Add(TExpressionFuncMilliSecondsBetween);
    Add(TExpressionFuncYearSpan);
    Add(TExpressionFuncMonthSpan);
    Add(TExpressionFuncWeekSpan);
    Add(TExpressionFuncDaySpan);
    Add(TExpressionFuncHourSpan);
    Add(TExpressionFuncMinuteSpan);
    Add(TExpressionFuncSecondSpan);
    Add(TExpressionFuncMilliSecondSpan);
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastYears = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastYears.Symbol: string;
begin
  Result := 'WithinPastYears';
end;
procedure TExpressionFuncWithinPastYears.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vYears: integer;
  vThen: TDateTime;
begin
  with AStack do begin
    vYears := Pop;
    vThen := Pop;
    Push(WithinPastYears(Pop, vThen, vYears));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastMonths = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastMonths.Symbol: string;
begin
  Result := 'WithinPastMonths';
end;
procedure TExpressionFuncWithinPastMonths.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMonths: integer;
  vThen: TDateTime;
begin
  with AStack do begin
    vMonths := Pop;
    vThen := Pop;
    Push(WithinPastMonths(Pop, vThen, vMonths));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastWeeks = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastWeeks.Symbol: string;
begin
  Result := 'WithinPastWeeks';
end;
procedure TExpressionFuncWithinPastWeeks.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vWeeks: integer;
  vThen: TDateTime;
begin
  with AStack do begin
    vWeeks := Pop;
    vThen := Pop;
    Push(WithinPastWeeks(Pop, vThen, vWeeks));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastDays = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastDays.Symbol: string;
begin
  Result := 'WithinPastDays';
end;
procedure TExpressionFuncWithinPastDays.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vDays: integer;
  vThen: TDateTime;
begin
  with AStack do begin
    vDays := Pop;
    vThen := Pop;
    Push(WithinPastDays(Pop, vThen, vDays));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastHours = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastHours.Symbol: string;
begin
  Result := 'WithinPastHours';
end;
procedure TExpressionFuncWithinPastHours.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vHours: comp;
  vThen: TDateTime;
begin
  with AStack do begin
    vHours := Pop;
    vThen := Pop;
    Push(WithinPastHours(Pop, vThen, vHours));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastMinutes = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastMinutes.Symbol: string;
begin
  Result := 'WithinPastMinutes';
end;
procedure TExpressionFuncWithinPastMinutes.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMinutes: comp;
  vThen: TDateTime;
begin
  with AStack do begin
    vMinutes := Pop;
    vThen := Pop;
    Push(WithinPastMinutes(Pop, vThen, vMinutes));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastSeconds = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastSeconds.Symbol: string;
begin
  Result := 'WithinPastSeconds';
end;
procedure TExpressionFuncWithinPastSeconds.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vSeconds: comp;
  vThen: TDateTime;
begin
  with AStack do begin
    vSeconds := Pop;
    vThen := Pop;
    Push(WithinPastSeconds(Pop, vThen, vSeconds));
  end;
end;

//==============================================================================
// TExpressionFuncWithinPastMilliSeconds = class(TExpressionFunctionWith3Arg)
//==============================================================================
class function TExpressionFuncWithinPastMilliSeconds.Symbol: string;
begin
  Result := 'WithinPastMilliSeconds';
end;
procedure TExpressionFuncWithinPastMilliSeconds.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vMilliSeconds: comp;
  vThen: TDateTime;
begin
  with AStack do begin
    vMilliSeconds := Pop;
    vThen := Pop;
    Push(WithinPastMilliSeconds(Pop, vThen, vMilliSeconds));
  end;
end;

//==============================================================================
// TExpressionFuncYearsBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncYearsBetween.Symbol: string;
begin
  Result := 'YearsBetween';
end;
procedure TExpressionFuncYearsBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(YearsBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMonthsBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMonthsBetween.Symbol: string;
begin
  Result := 'MonthsBetween';
end;
procedure TExpressionFuncMonthsBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MonthsBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncWeeksBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncWeeksBetween.Symbol: string;
begin
  Result := 'WeeksBetween';
end;
procedure TExpressionFuncWeeksBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(WeeksBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncDaysBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncDaysBetween.Symbol: string;
begin
  Result := 'DaysBetween';
end;
procedure TExpressionFuncDaysBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(DaysBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncHoursBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncHoursBetween.Symbol: string;
begin
  Result := 'HoursBetween';
end;
procedure TExpressionFuncHoursBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(HoursBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMinutesBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMinutesBetween.Symbol: string;
begin
  Result := 'MinutesBetween';
end;
procedure TExpressionFuncMinutesBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MinutesBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncSecondsBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncSecondsBetween.Symbol: string;
begin
  Result := 'SecondsBetween';
end;
procedure TExpressionFuncSecondsBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(SecondsBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMilliSecondsBetween = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMilliSecondsBetween.Symbol: string;
begin
  Result := 'MilliSecondsBetween';
end;
procedure TExpressionFuncMilliSecondsBetween.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MilliSecondsBetween(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncYearSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncYearSpan.Symbol: string;
begin
  Result := 'YearSpan';
end;
procedure TExpressionFuncYearSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(YearSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMonthSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMonthSpan.Symbol: string;
begin
  Result := 'MonthSpan';
end;
procedure TExpressionFuncMonthSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MonthSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncWeekSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncWeekSpan.Symbol: string;
begin
  Result := 'WeekSpan';
end;
procedure TExpressionFuncWeekSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(WeekSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncDaySpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncDaySpan.Symbol: string;
begin
  Result := 'DaySpan';
end;
procedure TExpressionFuncDaySpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(DaySpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncHourSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncHourSpan.Symbol: string;
begin
  Result := 'HourSpan';
end;
procedure TExpressionFuncHourSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(HourSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMinuteSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMinuteSpan.Symbol: string;
begin
  Result := 'MinuteSpan';
end;
procedure TExpressionFuncMinuteSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MinuteSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncSecondSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncSecondSpan.Symbol: string;
begin
  Result := 'SecondSpan';
end;
procedure TExpressionFuncSecondSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(SecondSpan(Pop, vThen));
  end;
end;

//==============================================================================
// TExpressionFuncMilliSecondSpan = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncMilliSecondSpan.Symbol: string;
begin
  Result := 'MilliSecondSpan';
end;
procedure TExpressionFuncMilliSecondSpan.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vThen: TDateTime;
begin
  with AStack do begin
    vThen := Pop;
    Push(MilliSecondSpan(Pop, vThen));
  end;
end;

end.
