unit ExpressionFuncsPathFileExtended;

// ExpressionFuncsPathFileExtended
// filepath    = RootOf, FolderOf, ParentOfPathOf, DirOf, UNCPathOf, IsLocal,
//               OnlyNameOf, CreationOf, LastAccessOf, EnglishSizeOf,
//               EnglishAttributesOf, IsReadOnly, IsHidden, IsSystem,
//               IsDirectory, IsArchive, IsCompressed, FileTypeOf,
//               ApplicationFor, VersionValueOf, VersionValueExists

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser;

//==============================================================================
type
  //============================================================================
  // filepath
  TExpressionFuncRootOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncFolderOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncParentOfPathOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncDirOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncUNCPathOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsLocal = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncOnlyNameOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncCreationOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncLastAccessOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEnglishSizeOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncEnglishAttributesOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsReadOnly = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsHidden = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsSystem = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsDirectory = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsArchive = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncIsCompressed = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncFileTypeOf = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncApplicationFor = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncVersionValueOf = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TExpressionFuncVersionExistsOf = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  MiscSupport, ResultSupport, FileInfoSupport, VersionInfoSupport;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncRootOf);
    Add(TExpressionFuncFolderOf);
    Add(TExpressionFuncParentOfPathOf);
    Add(TExpressionFuncDirOf);
    Add(TExpressionFuncUNCPathOf);
    Add(TExpressionFuncIsLocal);
    Add(TExpressionFuncOnlyNameOf);
    Add(TExpressionFuncCreationOf);
    Add(TExpressionFuncLastAccessOf);
    Add(TExpressionFuncEnglishSizeOf);
    Add(TExpressionFuncEnglishAttributesOf);
    Add(TExpressionFuncFileTypeOf);
    Add(TExpressionFuncApplicationFor);
    Add(TExpressionFuncIsReadOnly);
    Add(TExpressionFuncIsHidden);
    Add(TExpressionFuncIsSystem);
    Add(TExpressionFuncIsDirectory);
    Add(TExpressionFuncIsArchive);
    Add(TExpressionFuncIsCompressed);
    Add(TExpressionFuncVersionValueOf);
    Add(TExpressionFuncVersionExistsOf);
  end;
end;

//==============================================================================
// TExpressionFuncRootOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncRootOf.Symbol: string;
begin
  Result := 'RootOf';
end;
procedure TExpressionFuncRootOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Root);
end;

//==============================================================================
// TExpressionFuncFolderOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncFolderOf.Symbol: string;
begin
  Result := 'FolderOf';
end;
procedure TExpressionFuncFolderOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Folder);
end;

//==============================================================================
// TExpressionFuncParentOfPathOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncParentOfPathOf.Symbol: string;
begin
  Result := 'ParentOfPathOf';
end;
procedure TExpressionFuncParentOfPathOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).ParentOfPath);
end;

//==============================================================================
// TExpressionFuncDirOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDirOf.Symbol: string;
begin
  Result := 'DirOf';
end;
procedure TExpressionFuncDirOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).FileDir);
end;

//==============================================================================
// TExpressionFuncUNCPathOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncUNCPathOf.Symbol: string;
begin
  Result := 'UNCPathOf';
end;
procedure TExpressionFuncUNCPathOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).UNC);
end;

//==============================================================================
// TExpressionFuncIsLocal = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsLocal.Symbol: string;
begin
  Result := 'IsLocal';
end;
procedure TExpressionFuncIsLocal.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Local);
end;

//==============================================================================
// TExpressionFuncOnlyNameOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncOnlyNameOf.Symbol: string;
begin
  Result := 'OnlyNameOf';
end;
procedure TExpressionFuncOnlyNameOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).SansExtension);
end;

//==============================================================================
// TExpressionFuncCreationOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCreationOf.Symbol: string;
begin
  Result := 'CreationOf';
end;
procedure TExpressionFuncCreationOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).CreationAsDateTime);
end;

//==============================================================================
// TExpressionFuncLastAccessOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncLastAccessOf.Symbol: string;
begin
  Result := 'LastAccessOf';
end;
procedure TExpressionFuncLastAccessOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).LastAccessAsDateTime);
end;

//==============================================================================
// TExpressionFuncEnglishSizeOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEnglishSizeOf.Symbol: string;
begin
  Result := 'EnglishSizeOf';
end;
procedure TExpressionFuncEnglishSizeOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).SizeAsEnglish);
end;

//==============================================================================
// TExpressionFuncEnglishAttributesOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncEnglishAttributesOf.Symbol: string;
begin
  Result := 'EnglishAttributesOf';
end;
procedure TExpressionFuncEnglishAttributesOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).AttributesAsEnglish);
end;


//==============================================================================
// TExpressionFuncIsReadOnly = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsReadOnly.Symbol: string;
begin
  Result := 'IsReadOnly';
end;
procedure TExpressionFuncIsReadOnly.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).ReadOnly);
end;

//==============================================================================
// TExpressionFuncIsHidden = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsHidden.Symbol: string;
begin
  Result := 'IsHidden';
end;
procedure TExpressionFuncIsHidden.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Hidden);
end;

//==============================================================================
// TExpressionFuncIsSystem = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsSystem.Symbol: string;
begin
  Result := 'IsSystem';
end;
procedure TExpressionFuncIsSystem.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).System);
end;

//==============================================================================
// TExpressionFuncIsDirectory = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsDirectory.Symbol: string;
begin
  Result := 'IsDirectory';
end;
procedure TExpressionFuncIsDirectory.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Directory);
end;

//==============================================================================
// TExpressionFuncIsArchive = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsArchive.Symbol: string;
begin
  Result := 'IsArchive';
end;
procedure TExpressionFuncIsArchive.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Archive);
end;

//==============================================================================
// TExpressionFuncIsCompressed = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncIsCompressed.Symbol: string;
begin
  Result := 'IsCompressed';
end;
procedure TExpressionFuncIsCompressed.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Compressed);
end;

//==============================================================================
// TExpressionFuncFileTypeOf = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncFileTypeOf.Symbol: string;
begin
  Result := 'FileTypeOf';
end;
procedure TExpressionFuncFileTypeOf.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).FileType);
end;

//==============================================================================
// TExpressionFuncApplicationFor = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncApplicationFor.Symbol: string;
begin
  Result := 'ApplicationFor';
end;
procedure TExpressionFuncApplicationFor.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  with AStack do
    Push(FileInfoFor(Pop).Application);
end;

//==============================================================================
// TExpressionFuncVersionValueOf = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncVersionValueOf.Symbol: string;
begin
  Result := 'VersionValueOf';
end;
procedure TExpressionFuncVersionValueOf.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vName: string;
begin
  with AStack do begin
    vName := Pop;
    Push(FileInfoFor(Pop).VersionValue[vName]);
  end;
end;

//==============================================================================
// TExpressionFuncVersionExistsOf = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncVersionExistsOf.Symbol: string;
begin
  Result := 'VersionExistsOf';
end;
procedure TExpressionFuncVersionExistsOf.Execute(Sender: TObject; AStack: TExpressionStack);
var
  vName: string;
begin
  with AStack do begin
    vName := Pop;
    Push(FileInfoFor(Pop).VersionInfo.Defined(vName));
  end;
end;

end.
