unit ExpressionFuncsReals;

// ExpressionFuncsReals
// double      = MinReal, MaxReal, Pi, Exp,
//               Numerator, Denominator, Ceil, Floor, 
//               Tan, Sin, Cos, ArcTan, ArcSin, ArcCos,
//               TanH, SinH, CosH, ArcTanH, ArcSinH, ArcCosH,
//               RadToGrad, RadToDeg, RadToCycle,
//               GradToRad, DegToRad, CycleToRad,
//               Log10, Log2, LogN, Ln

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, ExpressionStack, ExpressionLexicon,
  ExpressionParser;

//==============================================================================
type
  //============================================================================
  // values
  TExpressionFuncMinReal = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncMaxReal = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncPi = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;

  //============================================================================
  // functions
  TExpressionFuncNumerator = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncDenominator = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncTan = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncSin = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncCos = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcTan = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcSin = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcCos = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncCosh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncSinh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncTanh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcCosh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcSinh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncArcTanh = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncDegToRad = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncRadToDeg = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncGradToRad = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncRadToGrad = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncCycleToRad = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncRadToCycle = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncLog10 = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncLog2 = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncCeil = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncExp = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncFloor = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncLogN = class(TExpressionFunctionWith2Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;
  TExpressionFuncLn = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    procedure Execute(Sender: TObject; aStack: TExpressionStack); override;
  end;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport, Math;

//==============================================================================
procedure RegisterLexicon(aParser: TCustomExpressionParser);
begin
  with aParser.FunctionLexicon do begin
    Add(TExpressionFuncMinReal);
    Add(TExpressionFuncMaxReal);
    Add(TExpressionFuncPi);
    Add(TExpressionFuncNumerator);
    Add(TExpressionFuncDenominator);
    Add(TExpressionFuncTan);
    Add(TExpressionFuncSin);
    Add(TExpressionFuncCos);
    Add(TExpressionFuncArcTan);
    Add(TExpressionFuncArcSin);
    Add(TExpressionFuncArcCos);
    Add(TExpressionFuncCosh);
    Add(TExpressionFuncSinh);
    Add(TExpressionFuncTanh);
    Add(TExpressionFuncArcCosh);
    Add(TExpressionFuncArcSinh);
    Add(TExpressionFuncArcTanh);
    Add(TExpressionFuncDegToRad);
    Add(TExpressionFuncRadToDeg);
    Add(TExpressionFuncGradToRad);
    Add(TExpressionFuncRadToGrad);
    Add(TExpressionFuncCycleToRad);
    Add(TExpressionFuncRadToCycle);
    Add(TExpressionFuncLog10);
    Add(TExpressionFuncLog2);
    Add(TExpressionFuncCeil);
    Add(TExpressionFuncExp);
    Add(TExpressionFuncFloor);
    Add(TExpressionFuncLogN);
    Add(TExpressionFuncLn);
  end;
end;

//==============================================================================
// TExpressionFuncMinReal = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncMinReal.Symbol: string;
begin
  Result := 'MinReal';
end;
procedure TExpressionFuncMinReal.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(MinDouble);
end;

//==============================================================================
// TExpressionFuncMaxReal = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncMaxReal.Symbol: string;
begin
  Result := 'MaxReal';
end;
procedure TExpressionFuncMaxReal.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(MaxDouble);
end;

//==============================================================================
// TExpressionFuncPi = class(TExpressionFunction)
//==============================================================================
class function TExpressionFuncPi.Symbol: string;
begin
  Result := 'Pi';
end;
procedure TExpressionFuncPi.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Pi);
end;

//==============================================================================
// TExpressionFuncNumerator = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncNumerator.Symbol: string;
begin
  Result := 'Numerator';
end;
procedure TExpressionFuncNumerator.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Frac(Pop));
end;

//==============================================================================
// TExpressionFuncDenominator = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDenominator.Symbol: string;
begin
  Result := 'Denominator';
end;
procedure TExpressionFuncDenominator.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Int(Pop));
end;

//==============================================================================
// TExpressionFuncTan = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTan.Symbol: string;
begin
  Result := 'Tan';
end;
procedure TExpressionFuncTan.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Tan(Pop));
end;

//==============================================================================
// TExpressionFuncSin = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSin.Symbol: string;
begin
  Result := 'Sin';
end;
procedure TExpressionFuncSin.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Sin(Pop));
end;

//==============================================================================
// TExpressionFuncCos = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCos.Symbol: string;
begin
  Result := 'Cos';
end;
procedure TExpressionFuncCos.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Cos(Pop));
end;

//==============================================================================
// TExpressionFuncArcTan = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcTan.Symbol: string;
begin
  Result := 'ArcTan';
end;
procedure TExpressionFuncArcTan.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcTan(Pop));
end;

//==============================================================================
// TExpressionFuncArcSin = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcSin.Symbol: string;
begin
  Result := 'ArcSin';
end;
procedure TExpressionFuncArcSin.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcSin(Pop));
end;

//==============================================================================
// TExpressionFuncArcCos = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcCos.Symbol: string;
begin
  Result := 'ArcCos';
end;
procedure TExpressionFuncArcCos.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcCos(Pop));
end;

//==============================================================================
// TExpressionFuncCosh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCosh.Symbol: string;
begin
  Result := 'Cosh';
end;
procedure TExpressionFuncCosh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Cosh(Pop));
end;

//==============================================================================
// TExpressionFuncSinh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncSinh.Symbol: string;
begin
  Result := 'Sinh';
end;
procedure TExpressionFuncSinh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Sinh(Pop));
end;

//==============================================================================
// TExpressionFuncTanh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncTanh.Symbol: string;
begin
  Result := 'Tanh';
end;
procedure TExpressionFuncTanh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Tanh(Pop));
end;

//==============================================================================
// TExpressionFuncArcCosh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcCosh.Symbol: string;
begin
  Result := 'ArcCosh';
end;
procedure TExpressionFuncArcCosh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcCosh(Pop));
end;

//==============================================================================
// TExpressionFuncArcSinh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcSinh.Symbol: string;
begin
  Result := 'ArcSinh';
end;
procedure TExpressionFuncArcSinh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcSinh(Pop));
end;

//==============================================================================
// TExpressionFuncArcTanh = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncArcTanh.Symbol: string;
begin
  Result := 'ArcTanh';
end;
procedure TExpressionFuncArcTanh.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(ArcTanh(Pop));
end;

//==============================================================================
// TExpressionFuncDegToRad = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncDegToRad.Symbol: string;
begin
  Result := 'DegToRad';
end;
procedure TExpressionFuncDegToRad.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(DegToRad(Pop));
end;

//==============================================================================
// TExpressionFuncRadToDeg = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncRadToDeg.Symbol: string;
begin
  Result := 'RadToDeg';
end;
procedure TExpressionFuncRadToDeg.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(RadToDeg(Pop));
end;

//==============================================================================
// TExpressionFuncGradToRad = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncGradToRad.Symbol: string;
begin
  Result := 'GradToRad';
end;
procedure TExpressionFuncGradToRad.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(GradToRad(Pop));
end;

//==============================================================================
// TExpressionFuncRadToGrad = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncRadToGrad.Symbol: string;
begin
  Result := 'RadToGrad';
end;
procedure TExpressionFuncRadToGrad.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(RadToGrad(Pop));
end;

//==============================================================================
// TExpressionFuncCycleToRad = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCycleToRad.Symbol: string;
begin
  Result := 'CycleToRad';
end;
procedure TExpressionFuncCycleToRad.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(CycleToRad(Pop));
end;

//==============================================================================
// TExpressionFuncRadToCycle = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncRadToCycle.Symbol: string;
begin
  Result := 'RadToCycle';
end;
procedure TExpressionFuncRadToCycle.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(RadToCycle(Pop));
end;

//==============================================================================
// TExpressionFuncLog10 = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncLog10.Symbol: string;
begin
  Result := 'Log10';
end;
procedure TExpressionFuncLog10.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Log10(Pop));
end;

//==============================================================================
// TExpressionFuncLog2 = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncLog2.Symbol: string;
begin
  Result := 'Log2';
end;
procedure TExpressionFuncLog2.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Log2(Pop));
end;

//==============================================================================
// TExpressionFuncCeil = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncCeil.Symbol: string;
begin
  Result := 'Ceil';
end;
procedure TExpressionFuncCeil.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Ceil(Pop));
end;

//==============================================================================
// TExpressionFuncExp = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncExp.Symbol: string;
begin
  Result := 'Exp';
end;
procedure TExpressionFuncExp.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Exp(Pop));
end;

//==============================================================================
// TExpressionFuncFloor = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncFloor.Symbol: string;
begin
  Result := 'Floor';
end;
procedure TExpressionFuncFloor.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Floor(Pop));
end;

//==============================================================================
// TExpressionFuncLogN = class(TExpressionFunctionWith2Arg)
//==============================================================================
class function TExpressionFuncLogN.Symbol: string;
begin
  Result := 'LogN';
end;
procedure TExpressionFuncLogN.Execute(Sender: TObject; aStack: TExpressionStack);
var
  vValue: extended;
begin
  with aStack do begin
    vValue := Pop;
    Push(LogN(Pop, vValue));
  end;
end;

//==============================================================================
// TExpressionFuncLn = class(TExpressionFunctionWith1Arg)
//==============================================================================
class function TExpressionFuncLn.Symbol: string;
begin
  Result := 'Ln';
end;
procedure TExpressionFuncLn.Execute(Sender: TObject; aStack: TExpressionStack);
begin
  with aStack do
    Push(Ln(Pop));
end;

end.
