unit ExpressionStack;

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, MiscSupport, StackSupport,Variants;

//==============================================================================
type
  //============================================================================
  TExpressionStack = class(TObjectStack)
  public
    procedure Push(const AValue: variant); virtual;
    function Pop: variant; virtual;
    function Peek: variant; virtual;
  end;

//==============================================================================
implementation

//==============================================================================
uses
  ResultSupport;

//==============================================================================
type
  //============================================================================
  TExpressionStackValue = class(TObject)
  public
    Value: variant;
    constructor Create(const AValue: variant);
  end;

//==============================================================================
// TExpressionStack = class(TObjectStack)
//==============================================================================
procedure TExpressionStack.Push(const AValue: variant);
begin
  Assert(VarType(AValue) <> varUnknown, ResultTextFor(OLE_E_BLANK));
  PushObject(TExpressionStackValue.Create(AValue));
end;
function TExpressionStack.Pop: variant;
begin
  Result := Peek;
  TExpressionStackValue(PopObject).Free;
end;
function TExpressionStack.Peek: variant;
begin
  Result := TExpressionStackValue(PeekObject).Value;
end;

//==============================================================================
constructor TExpressionStackValue.Create(const AValue: variant);
begin
  inherited Create;
  Value := AValue;
end;

end.
