unit ExpressionSupport;

//==============================================================================
interface

//==============================================================================
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls;

//==============================================================================
procedure ShowCaratUnder(aBox: TControl; aWidth, aIndex: integer);

//==============================================================================
implementation

//==============================================================================
type
  TCustomControlWithCanvas = class(TCustomControl)
  public
    property Canvas;
  end;

//==============================================================================
procedure ShowCaratUnder(aBox: TControl; aWidth, aIndex: integer);
var
  vRect: TRect;
  vCanvas: TCanvas;
  vLeft: integer;
begin
  // where is the carat area?
  with aBox do
    vRect := Bounds(Left, Top + Height, Width, 6);

  // where is the canvas?
  if aBox.Parent is TCustomForm then
    vCanvas := TCustomForm(aBox.Parent).Canvas
  else if aBox.Parent is TCustomControl then
    vCanvas := TCustomControlWithCanvas(aBox.Parent).Canvas
  else
    vCanvas := nil;

  // did we find one?
  if Assigned(vCanvas) then with vCanvas do begin

    // clear
    Brush.Color := clBtnFace;
    FillRect(vRect);

    // something to do?
    if aIndex >= 0 then begin

      // change the colors a bit
      Pen.Color := clBlack;
      Brush.Color := clRed;

      // what we came here for
      vLeft := vRect.Left + 2 + (aIndex - 1) * aWidth;
      Polygon([Point(vLeft,              vRect.Top),
               Point(vLeft,              vRect.Top + 5),
               Point(vLeft + aWidth + 1, vRect.Top + 5),
               Point(vLeft + aWidth + 1, vRect.Top),
               Point(vLeft + aWidth - 1, vRect.Top),
               Point(vLeft + aWidth - 1, vRect.Top + 2),
               Point(vLeft + 2,          vRect.Top + 2),
               Point(vLeft + 2,          vRect.Top)]);
    end;
  end;
end;

end.
