unit MatchingSupport;

//==============================================================================
interface

//==============================================================================
function Resembles(const aValue, aPattern: string): boolean;
function Matches(const aValue, aPattern: string): boolean;

//==============================================================================
implementation

//==============================================================================
{$ifdef UseXProcs}
uses
  xProcs;
{$endif}

//==============================================================================
function Resembles(const aValue, aPattern: string): boolean;
begin
  // phonex/metaphone/soundex/guth matching
  {$ifdef UseXProcs}
    Result := strSoundex(aValue) = strSoundex(aPattern);
  {$else}
    Result := False;
  {$endif}
end;
function Matches(const aValue, aPattern: string): boolean;
begin
  // pattern matching
  {$ifdef UseXProcs}
    Result := strMatch(aValue, aPattern);
  {$else}
    Result := False;
  {$endif}
end;

end.
