unit MiscConstants;

//==============================================================================
interface

//==============================================================================
type
  TCharSet = set of char;

//==============================================================================
const
  cIndexNotFound = -1;
  cGigabyte = 1024 * 1024 * 1024;
  cMegabyte = 1024 * 1024;
  cKilobyte = 1024;

  //============================================================================
  cWhiteSpace: TCharSet = [#1..#32];
  cSymbols: TCharSet    = [#33..#47, #58..#64, #91..#96, #123..#126];
  cLetters: TCharSet    = ['A'..'Z', 'a'..'z'];
  cVowels: TCharSet     = ['A', 'E', 'I', 'O', 'U', 'Y',
                           'a', 'e', 'i', 'o', 'u', 'y'];
  cDigits: TCharSet     = ['0'..'9'];
  cHexDigits: TCharSet  = ['0'..'9', 'A'..'F', 'a'..'f'];
  cLetterNDigits: TCharSet = ['0'..'9', 'A'..'Z', 'a'..'z'];
  cValidAscii: TCharSet = [#32, #33, #35..#255];
  cHighAscii: TCharSet  = [#127..#255];

  //============================================================================
  cSymbolStart: TCharSet = ['A'..'Z', 'a'..'z', '_'];
  cSymbolFinish: TCharSet = ['0'..'9', 'A'..'Z', 'a'..'z', '_'];

  //============================================================================
  cNewLine = #13;

//==============================================================================
implementation

end.
